<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.vetti.hotake.mapper.HotakeCvInfoMapper">
    
    <resultMap type="HotakeCvInfo" id="HotakeCvInfoResult">
        <result property="id"    column="id"    />
        <result property="userId"    column="user_id"    />
        <result property="cvName"    column="cv_name"    />
        <result property="cvFileType"    column="cv_file_type"    />
        <result property="cvUrl"    column="cv_url"    />
        <result property="fileSizeShow"    column="file_size_show"    />
        <result property="cvFileSuffix" column="cv_file_suffix" />
        <result property="status"    column="status"    />
        <result property="cvTemplateJson" column="cv_template_json" />
        <result property="cvScore" column="cv_score" />
        <result property="cvMd5" column="cv_md5" />

        <result property="experience" column="experience" />
        <result property="aiMatchScore" column="ai_match_score" />
        <result property="aiMatchScorePercentage" column="ai_match_score_percentage" />

        <result property="cvOptimizeJson" column="cv_optimize_json" />

        <result property="analyzedAttachmentJson" column="analyzed_attachment_json" />

        <result property="dataType" column="data_type" />

        <result property="delFlag"            column="del_flag"              />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectHotakeCvInfoVo">
        select id, user_id, cv_name, cv_file_type, cv_url,file_size_show,cv_file_suffix,
               status,cv_template_json,cv_score,cv_md5,experience,ai_match_score,ai_match_score_percentage,
               cv_optimize_json,analyzed_attachment_json,data_type,
               del_flag, create_by, create_time, update_by, update_time, remark from hotake_cv_info
    </sql>

    <select id="selectHotakeCvInfoList" parameterType="HotakeCvInfo" resultMap="HotakeCvInfoResult">
        <include refid="selectHotakeCvInfoVo"/>
        <where>  
            <if test="userId != null "> and user_id = #{userId}</if>
            <if test="cvName != null  and cvName != ''"> and cv_name like concat('%', #{cvName}, '%')</if>
            <if test="cvFileType != null  and cvFileType != ''"> and cv_file_type = #{cvFileType}</if>
            <if test="cvUrl != null  and cvUrl != ''"> and cv_url = #{cvUrl}</if>
            <if test="cvFileSuffix != null  and cvFileSuffix != ''"> and cv_file_suffix = #{cvFileSuffix}</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
            <if test="dataType != null  and dataType != ''"> and data_type = #{dataType}</if>
            <if test="delFlag != null  and delFlag != ''"> and del_flag = #{delFlag}</if>
        </where>
    </select>
    
    <select id="selectHotakeCvInfoById" parameterType="Long" resultMap="HotakeCvInfoResult">
        <include refid="selectHotakeCvInfoVo"/>
        where id = #{id}
    </select>
        
    <insert id="insertHotakeCvInfo" parameterType="HotakeCvInfo" useGeneratedKeys="true" keyProperty="id">
        insert into hotake_cv_info
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="userId != null">user_id,</if>
            <if test="cvName != null">cv_name,</if>
            <if test="cvFileType != null">cv_file_type,</if>
            <if test="cvUrl != null">cv_url,</if>
            <if test="fileSizeShow != null">file_size_show,</if>
            <if test="cvFileSuffix != null">cv_file_suffix,</if>
            <if test="status != null">status,</if>
            <if test="cvTemplateJson != null">cv_template_json,</if>
            <if test="cvScore != null">cv_score,</if>
            <if test="cvMd5 != null">cv_md5,</if>

            <if test="experience != null">experience,</if>
            <if test="aiMatchScore != null">ai_match_score,</if>
            <if test="aiMatchScorePercentage != null">ai_match_score_percentage,</if>
            <if test="cvOptimizeJson != null">cv_optimize_json,</if>

            <if test="analyzedAttachmentJson != null">analyzed_attachment_json,</if>

            <if test="dataType != null">data_type,</if>

            <if test="delFlag != null">del_flag,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="userId != null">#{userId},</if>
            <if test="cvName != null">#{cvName},</if>
            <if test="cvFileType != null">#{cvFileType},</if>
            <if test="cvUrl != null">#{cvUrl},</if>
            <if test="fileSizeShow != null">#{fileSizeShow},</if>
            <if test="cvFileSuffix != null">#{cvFileSuffix},</if>
            <if test="status != null">#{status},</if>
            <if test="cvTemplateJson != null">#{cvTemplateJson},</if>
            <if test="cvScore != null">#{cvScore},</if>
            <if test="cvMd5 != null">#{cvMd5},</if>

            <if test="experience != null">#{experience},</if>
            <if test="aiMatchScore != null">#{aiMatchScore},</if>
            <if test="aiMatchScorePercentage != null">#{aiMatchScorePercentage},</if>
            <if test="cvOptimizeJson != null">#{cvOptimizeJson},</if>

            <if test="analyzedAttachmentJson != null">#{analyzedAttachmentJson},</if>
            <if test="dataType != null">#{dataType},</if>

            <if test="delFlag != null">#{delFlag},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateHotakeCvInfo" parameterType="HotakeCvInfo">
        update hotake_cv_info
        <trim prefix="SET" suffixOverrides=",">
            <if test="userId != null">user_id = #{userId},</if>
            <if test="cvName != null">cv_name = #{cvName},</if>
            <if test="cvFileType != null">cv_file_type = #{cvFileType},</if>
            <if test="cvUrl != null">cv_url = #{cvUrl},</if>
            <if test="fileSizeShow != null">file_size_show = #{fileSizeShow},</if>
            <if test="cvFileSuffix != null">cv_file_suffix = #{cvFileSuffix},</if>
            <if test="status != null">status = #{status},</if>
            <if test="cvTemplateJson != null">cv_template_json = #{cvTemplateJson},</if>
            <if test="cvScore != null">cv_score = #{cvScore},</if>
            <if test="cvMd5 != null">cv_md5 = #{cvMd5},</if>

            <if test="experience != null">experience = #{experience},</if>
            <if test="aiMatchScore != null">ai_match_score = #{aiMatchScore},</if>
            <if test="aiMatchScorePercentage != null">ai_match_score_percentage = #{aiMatchScorePercentage},</if>

            <if test="cvOptimizeJson != null">cv_optimize_json = #{cvOptimizeJson},</if>

            <if test="analyzedAttachmentJson != null">analyzed_attachment_json = #{analyzedAttachmentJson},</if>

            <if test="dataType != null">data_type = #{dataType},</if>

            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteHotakeCvInfoById" parameterType="Long">
        delete from hotake_cv_info where id = #{id}
    </delete>

    <delete id="deleteHotakeCvInfoByUserIdAndType" >
        delete from hotake_cv_info where user_id = #{userId} and cv_file_type = #{cvFileType}

    </delete>

    <delete id="deleteHotakeCvInfoByIds" parameterType="String">
        delete from hotake_cv_info where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>

    <insert id="batchInsertHotakeCvInfo">
        insert into hotake_cv_info( id, user_id, cv_name, cv_file_type, cv_url, status, cv_file_suffix,del_flag,
                                   create_by, create_time, update_by, update_time, remark) values
        <foreach item="item" index="index" collection="list" separator=",">
            ( #{item.id}, #{item.userId}, #{item.cvName}, #{item.cvFileType}, #{item.cvUrl}, #{item.status},#{cvFileSuffix}, #{item.delFlag},
             #{item.createBy}, #{item.createTime}, #{item.updateBy}, #{item.updateTime}, #{item.remark})
        </foreach>
    </insert>
</mapper>